// pages/index/sw/index.js
const imgurl = require("../../utils/imgurl");
Component({
  /**
   * 组件的属性列表
   */
  properties: {
    list: {
      value: [],
      type: Array
    }
  },

  /**
   * 组件的初始数据
   */
  data: {
    bannerUrl: imgurl.banner.url,
    currentIndex: 0
  },

  /**
   * 组件的方法列表
   */
  methods: {
    gotobannerdetail: function(e) {
      if (e.currentTarget.dataset.data.type == 3) {
        // 小程序路径
        wx.redirectTo({
          url: `/${e.currentTarget.dataset.data.pagePath}`,
        })
      }else if(e.currentTarget.dataset.data.type==2){
        // 自由图文
        wx.navigateTo({
          url: `/pages/freeBannerDetail/index?id=${e.currentTarget.dataset.id}`
        });
      }else{
        // 固定格式
        wx.navigateTo({
          url: `/pages/bannerdetail/index?id=${e.currentTarget.dataset.id}`
        });
      }
    },
    handleChange: function (e) {
      this.setData({
        currentIndex: e.detail.current
      })
    },
  }
});
